# statistics.jl

Unit for statistics, probability and related functions.


| Category  | Output |
|:---------- |:----------- |
| 1. [Probability](@ref) | functions relating to probability |
| 2. [Descriptive Statistics](@ref) | functions relating to decriptive statistics |


## Probability

| Function   | Description |
|:---------- |:----------- |
| [`softmax`](@ref) | compute softmax probabilities |

```@docs
softmax
```

## Descriptive Statistics

| Function   | Description |
|:---------- |:----------- |
| [`mean`](@ref) | scalar mean of real or complex numbers according to the specified metric |
| [`std`](@ref) | scalar standard deviation of real or complex numbers according to the specified metric |


    mean(metric::Metric, ν::Vector{T}) where T<:RealOrComplex

See bottom of documentation of general function [`mean`](@ref)

```@docs
std
```
